const express = require('express');
var url = require('url');
var fs = require('fs');

var portnumber = 3038;
const server = express();
server.use(express.static("."));
server.listen(portnumber);
console.log("Now listening on port " + portnumber);

UPPER_CASE = 0;
LOWER_CASE = 1;
SYMBOLS_1 = 2;
SYMBOLS_2 = 3;

tablesForKeyboard = ['', '', '', '']; /* initialized at very end of file */



modus = UPPER_CASE;

contentString = '';

server.get('/', handleClick);
server.get('/click', handleClick);



function handleClick(req, res) {

    let content = req.query.content;
    if (!content) {
        content = '';
    }
    let modus = req.query.modus;
    if (!modus) {
        modus = UPPER_CASE;
    }

    let htmlString = htmlTopPart + '<span style="background-color:rgba(255,255,255,1)">' + decodeURIComponent(content) + '</span>' + htmlSecondPart +
        produceKeyboardString(modus, content) + `</body></html>`;
    res.send(htmlString);
}


function removeLast(s) {
    return encodeURIComponent(s.slice(0, s.length - 1));
}

function produceKeyboardString(modus, currentString) {

    function append(letter) {
        return encodeURIComponent(currentString + letter);
    }

    if (modus == LOWER_CASE) {
        function produceTD(c) {
            return `<td><a href="click?modus=${LOWER_CASE}&content=${append(c)}">${c}</a></td>`;
        }
        return `
    <div class="container">
    <table class="keyboard">
        <tbody>
            <tr>
                ${produceTD('q')}
                <td> </td>
                ${produceTD('w')}
                <td> </td>
                ${produceTD('e')}
                <td> </td>
                ${produceTD('r')}
                <td> </td>
                ${produceTD('t')}
                <td> </td>
                ${produceTD('y')}
                <td> </td>
                ${produceTD('u')}
                <td> </td>
                ${produceTD('i')}
                <td> </td>
                ${produceTD('o')}
                <td> </td>
                ${produceTD('p')}
            </tr>
            <tr>
                <td> </td>
                ${produceTD('a')}
                <td> </td>
                ${produceTD('s')}
                <td> </td>
                ${produceTD('d')}
                <td> </td>
                ${produceTD('f')}
                <td> </td>
                ${produceTD('g')}
                <td> </td>
                ${produceTD('h')}
                <td> </td>
                ${produceTD('j')}
                <td> </td>
                ${produceTD('k')}
                <td> </td>
                ${produceTD('l')}
            </tr>
            <tr>
                <td colspan="3">
                    <a href="click?modus=${UPPER_CASE}&content=${encodeURIComponent(currentString)}">
                        <img src="img/shift.svg" style="width:3ch">
                    </a>
                </td>
                ${produceTD('z')}
                <td> </td>
                ${produceTD('x')}
                <td> </td>
                ${produceTD('c')}   
                <td> </td>
                ${produceTD('v')}
                <td> </td>
                ${produceTD('b')}
                <td> </td>
                ${produceTD('n')}
                <td> </td>
                ${produceTD('m')}
                <td colspan="3" style="text-align:right">
                    <a href="click?modus=${LOWER_CASE}&content=${encodeURIComponent(removeLast(currentString))}">
                        <img src="img/delete.svg">
                    </a>
                </td>
            </tr>

            <tr>
                <td colspan="3"><a href="click?modus=${SYMBOLS_1}&content=${encodeURIComponent(currentString)}">123</a></td>
                <td> </td>
                ${produceTD('.')}
                <td> </td>
                <td colspan="7" style="text-align: center;">
                <a href="click?modus=${LOWER_CASE}&content=${append(' ')}">
                <img src="img/space.svg"
                            style="height:1.5em"></a></td>
                <td> </td>
                ${produceTD(',')}
                <td> </td>
                <td colspan="3" style="text-align:right">
                <a href="click?modus=${LOWER_CASE}&content=${append('\n')}"><img src="img/enter.svg"></a>
                </td>
            </tr>
        </tbody>
    </table>
</div>`;
    }
    else if (modus == UPPER_CASE) {
        function produceTD(c) {
            return `<td><a href="click?modus=${UPPER_CASE}&content=${append(c)}">${c}</a></td>`;
        }

        return `
        <div class="container">
        <table class="keyboard">
            <tbody>
                <tr>
                    ${produceTD('Q')}
                    <td> </td>
                    ${produceTD('W')}                       
                    <td> </td>
                    ${produceTD('E')}
                    <td> </td>
                    ${produceTD('R')}
                    <td> </td>
                    ${produceTD('T')}
                    <td> </td>
                    ${produceTD('Y')}
                    <td> </td>
                    ${produceTD('U')}
                    <td> </td>
                    ${produceTD('I')}
                    <td> </td>
                    ${produceTD('O')}
                    <td> </td>
                    ${produceTD('P')}
                </tr>
                <tr>
                    <td> </td>
                    ${produceTD('A')}
                    <td> </td>
                    ${produceTD('S')}
                    <td> </td>
                    ${produceTD('D')}
                    <td> </td>
                    ${produceTD('F')}
                    <td> </td>
                    ${produceTD('G')}
                    <td> </td>
                    ${produceTD('H')}
                    <td> </td>
                    ${produceTD('J')}
                    <td> </td>
                    ${produceTD('K')}
                    <td> </td>
                    ${produceTD('L')}
                </tr>
                <tr>
                    <td colspan="3">
                        <a href="click?modus=${LOWER_CASE}&content=${encodeURIComponent(currentString)}">
                            <img src="img/noshift.svg" style="width:3ch">
                        </a>
                    </td>
                    ${produceTD('Z')}
                    <td> </td>
                    ${produceTD('X')}   
                    <td> </td>
                    ${produceTD('C')}
                    <td> </td>
                    ${produceTD('V')}
                    <td> </td>
                    ${produceTD('B')}
                    <td> </td>
                    ${produceTD('N')}
                    <td> </td>
                    ${produceTD('M')}
                    <td colspan="3" style="text-align:right">
                        <a href="click?modus=${UPPER_CASE}&content=${encodeURIComponent(removeLast(currentString))}">
                            <img src="img/delete.svg">
                        </a>
                    </td>
                </tr>
                
                <tr>
                    <td colspan="3"><a href="click?modus=${SYMBOLS_1}&content=${encodeURIComponent(currentString)}">123</a></td>
                    <td> </td>
                    ${produceTD('.')}
                    <td> </td>
                    <td colspan="8" style="text-align: center;"><a href="click?modus=${UPPER_CASE}&content=${append(' ')}"><img src="img/space.svg"
                    style="height:1.5em"></a></td>
                    <td> </td>
                    ${produceTD(',')}
                    <td> </td>
                    <td colspan="2" style="text-align:right">
                    <a href="click?modus=${UPPER_CASE}&content=${append('\n')}"><img src="img/enter.svg" style="width:3ch"></a>
                    </td>
                </tr>

                
            </tbody>
        </table>
    </div>`;

    }
    else if (modus == SYMBOLS_1) {
        function produceTD(c) {
            return `<td><a href="click?modus=${SYMBOLS_1}&content=${append(c)}">${c}</a></td>`;
        }
        let result =
            `
    <div class="container">
<table class="keyboard">
    <tbody>
        <tr>
            ${produceTD('1')}
            <td> </td>
            ${produceTD('2')}
            <td> </td>
            ${produceTD('3')}
            <td> </td>
            ${produceTD('4')}
            <td> </td>
            ${produceTD('5')}
            <td> </td>
            ${produceTD('6')}
            <td> </td>
            ${produceTD('7')}
            <td> </td>
            ${produceTD('8')}
            <td> </td>
            ${produceTD('9')}
            <td> </td>
            ${produceTD('0')}
        </tr>
        <tr>
            ${produceTD('@')}
            <td> </td>
            ${produceTD('#')}
            <td> </td>
            ${produceTD('$')}
            <td> </td>
            ${produceTD('_')}
            <td> </td>
            ${produceTD('&')}
            <td> </td>
            ${produceTD('-')}
            <td> </td>
            ${produceTD('+')}
            <td> </td>
            ${produceTD('(')}
            <td> </td>
            ${produceTD(')')}
            <td> </td>
            ${produceTD('/')}
        </tr>

        <tr>
            <td colspan="3"><a href="click?modus=${SYMBOLS_2}&content=${encodeURIComponent(currentString)}">=\&lt;</a></td>
            ${produceTD('*')}
            <td> </td>
            ${produceTD('"')}
            <td> </td>
            ${produceTD("'")}
            <td> </td>
            ${produceTD(':')}
            <td> </td>
            ${produceTD(';')}
            <td> </td>
            ${produceTD('!')}
            <td> </td>
            ${produceTD('?')}
            <td colspan="3" style="text-align:right"><a href="click?modus=${SYMBOLS_1}&content=${removeLast(currentString)}"><img src="img/delete.svg"></a>
            </td>
        </tr>

        <tr>
            <td colspan="2"><a href="click?modus=${LOWER_CASE}&content=${encodeURIComponent(currentString)}">ABC</a></td>
            <td> </td>
            ${produceTD('.')}
            <td> </td>
            <td colspan="8" style="text-align: center;"><a href="click?modus=${SYMBOLS_1}&content=${append(' ')}"><img src="img/space.svg"
                        style="height:1.5em"></a></td>
            <td> </td>
            ${produceTD(',')}
            <td> </td>
            <td colspan="3" style="text-align:right"><a href="click?modus=${SYMBOLS_1}&content=${append('\n')}"><img src="img/enter.svg"></a>
            </td>
        </tr>
    </tbody>
</table>
</div>
`;
        return result;
    }
    else if (modus == SYMBOLS_2) {
        function produceTD(c) {
            return `<td><a href="click?modus=${SYMBOLS_2}&content=${append(c)}">${c}</a></td>`;
        }
        let result =
            `
<div class="container">
<table class="keyboard">
    <tbody>
        <tr>
            <td style="color:rgba(0,0,0,0)">a</td>
        </tr>
        <tr>
            <td> </td>
            <td> </td>
            ${produceTD('~')}
            <td> </td>
            ${produceTD('`')}
            <td> </td>
            ${produceTD('|')}
            <td> </td>
            ${produceTD('^')}
            <td> </td>
            ${produceTD('=')}
            <td> </td>
            ${produceTD('{')}
            <td> </td>
            ${produceTD('}')}
            <td> </td>
            ${produceTD('\\')}
            <td> </td>
        </tr>
        <tr>

            <td colspan="3">
                <a href="click?modus=${SYMBOLS_1}&content=${encodeURIComponent(currentString)}">-/+</a>
            </td>
            <td> </td>
            <td> </td>
            ${produceTD('[')}
            <td> </td>
            ${produceTD(']')}
            <td> </td>
            ${produceTD('%')}
            <td> </td>
            ${produceTD('&lt;')}
            <td> </td>
            ${produceTD('&gt;')}
            <td> </td>
            <td colspan="3" style="text-align:right">
                <a href="click?modus=${SYMBOLS_1}&content=${removeLast(currentString)}">
                    <img src="img/delete.svg">
                </a>
            </td>
        </tr>
        <tr>
            <td colspan="2"><a href="click?modus=${LOWER_CASE}&content=${encodeURIComponent(currentString)}">ABC</a></td>
            <td> </td>
            ${produceTD('.')}
            <td> </td>
            <td colspan="8" style="text-align: center;">
                <a href="click?modus=${SYMBOLS_2}&content=${append(' ')}">
                    <img src="img/space.svg"
                        style="height:1.5em">
                </a>
            </td>
            <td> </td>
            ${produceTD(',')}
            <td> </td>
            <td colspan="3" style="text-align:right"><a href="click?modus=${SYMBOLS_2}&content=${append('\n')}"><img src="img/enter.svg"></a>
            </td>
        </tr>
    </tbody>
</table>
</div>
`;
        return result;
    }
    else {
        return `invalid modus: ${modus}`;
    }
}




htmlTopPart =
    `
<!DOCTYPE html>
<html>
<head>
    <link rel="icon" href="data:,">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="img/https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="img/https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="./keyboard.css">
</head>
<body>
    <div class="container">
        <h3>Please enter your text here</h3>

        <pre>
`;

htmlSecondPart = `
</pre>
    </div>
`;

