const express = require('express');
var url = require('url');
var fs = require('fs');

var portnumber = 3037;
const server = express();
server.use(express.static("."));
server.listen(portnumber);
console.log("Now listening on port " + portnumber);

UPPER_CASE = 0;
LOWER_CASE = 1;
SYMBOLS_1 = 2;
SYMBOLS_2 = 3;

tablesForKeyboard = ['', '', '', '']; /* initialized at very end of file */

complexKeys = {
    "space": " ",
    "enter": "\n",
    "semicolon": ";",
    "colon": ":",
    "amp": "&",
    "bracketOpen": "[",
    "bracketClose": "]",
    "curlyOpen": "{",
    "curlyClose": "}",
    "lt": "&lt;",
    "gt": "&gt;",
    "slash": "/",
    "backslash": "\\",
    "percent": "%",
    "plus": "+",
    "exclamationMark": "!",
    "questionMark": "?",
    "tilde": "~",
    "backtick": "`",
    "vertDash": "|",
    "caret": "^",
    "equal": "=",

}



modus = UPPER_CASE;

contentString = '';

server.get('/', handleClick);
server.get('/click', handleClick);



function handleClick(req, res) {

    let clickedKey = req.query.key;
    if (clickedKey === "del") {
        contentString = contentString.slice(0, contentString.length - 1);
    }
    else if (clickedKey === "noshift") {
        modus = LOWER_CASE;
    }
    else if (clickedKey === "numbers") {
        modus = SYMBOLS_1;
    }
    else if (clickedKey === "other-symbols") {
        modus = SYMBOLS_2;
    }
    else if (clickedKey === "alphabet") {
        modus = LOWER_CASE;
    }
    else if (clickedKey && complexKeys[clickedKey]) { // translate "space" to " " and so on 
        contentString = contentString + complexKeys[clickedKey];
    }
    else if (clickedKey) {
        contentString = contentString + clickedKey;
    }


    let htmlString = htmlTopPart + '<span style="background-color:rgba(255,255,255,1)">' + contentString + '</span>' + htmlSecondPart + tablesForKeyboard[modus];
    res.send(htmlString);
}







tablesForKeyboard[LOWER_CASE] =
    `
    <div class="container">
    <table class="keyboard">
        <tbody>
            <tr>
                <td><a href="click?key=q">q</a></td>
                <td> </td>
                <td><a href="click?key=w">w</a></td>
                <td> </td>
                <td><a href="click?key=e">e</a></td>
                <td> </td>
                <td><a href="click?key=r">r</a></td>
                <td> </td>
                <td><a href="click?key=t">t</a></td>
                <td> </td>
                <td><a href="click?key=y">y</a></td>
                <td> </td>
                <td><a href="click?key=u">u</a></td>
                <td> </td>
                <td><a href="click?key=i">i</a></td>
                <td> </td>
                <td><a href="click?key=o">o</a></td>
                <td> </td>
                <td><a href="click?key=p">p</a></td>
            </tr>
            <tr>
                <td> </td>
                <td><a href="click?key=a">a</a></td>
                <td> </td>
                <td><a href="click?key=s">s</a></td>
                <td> </td>
                <td><a href="click?key=d">d</a></td>
                <td> </td>
                <td><a href="click?key=f">f</a></td>
                <td> </td>
                <td><a href="click?key=g">g</a></td>
                <td> </td>
                <td><a href="click?key=h">h</a></td>
                <td> </td>
                <td><a href="click?key=j">j</a></td>
                <td> </td>
                <td><a href="click?key=k">k</a></td>
                <td> </td>
                <td><a href="click?key=l">l</a></td>
            </tr>
            <tr>
                <td colspan="3"><a href="click?key=shift"><img src="img/shift.svg" style="width:3ch"></a></td>
                <td><a href=" click?key=z">z</a></td>
                <td> </td>
                <td><a href="click?key=x">x</a></td>
                <td> </td>
                <td><a href="click?key=c">c</a></td>
                <td> </td>
                <td><a href="click?key=v">v</a></td>
                <td> </td>
                <td><a href="click?key=b">b</a></td>
                <td> </td>
                <td><a href="click?key=n">n</a></td>
                <td> </td>
                <td><a href="click?key=m">m</a></td>
                <td colspan="3" style="text-align:right"><a href="click?key=del"><img src="img/delete.svg"></a>
                </td>
            </tr>

            <tr>
                <td colspan="3"><a href="click?key=numbers">123</a></td>
                <td> </td>
                <td><a href="click?key=.">.</a></td>
                <td> </td>
                <td colspan="7" style="text-align: center;"><a href="click?key=space"><img src="img/space.svg"
                            style="height:1.5em"></a></td>
                <td> </td>
                <td><a href="click?key=,">,</a></td>
                <td> </td>
                <td colspan="3" style="text-align:right"><a href="click?key=enter"><img src="img/enter.svg"></a>
                </td>
            </tr>
        </tbody>
    </table>
</div>`;


tablesForKeyboard[UPPER_CASE] =
    `

    <div class="container">
        <table class="keyboard">
            <tbody>
                <tr>
                    <td><a href="click?key=Q">Q</a></td>
                    <td> </td>
                    <td><a href="click?key=W">W</a></td>
                    <td> </td>
                    <td><a href="click?key=E">E</a></td>
                    <td> </td>
                    <td><a href="click?key=R">R</a></td>
                    <td> </td>
                    <td><a href="click?key=T">T</a></td>
                    <td> </td>
                    <td><a href="click?key=Y">Y</a></td>
                    <td> </td>
                    <td><a href="click?key=U">U</a></td>
                    <td> </td>
                    <td><a href="click?key=I">I</a></td>
                    <td> </td>
                    <td><a href="click?key=O">O</a></td>
                    <td> </td>
                    <td><a href="click?key=P">P</a></td>
                </tr>
                <tr>
                    <td> </td>
                    <td><a href="click?key=A">A</a></td>
                    <td> </td>
                    <td><a href="click?key=S">S</a></td>
                    <td> </td>
                    <td><a href="click?key=D">D</a></td>
                    <td> </td>
                    <td><a href="click?key=F">F</a></td>
                    <td> </td>
                    <td><a href="click?key=G">G</a></td>
                    <td> </td>
                    <td><a href="click?key=H">H</a></td>
                    <td> </td>
                    <td><a href="click?key=J">J</a></td>
                    <td> </td>
                    <td><a href="click?key=K">K</a></td>
                    <td> </td>
                    <td><a href="click?key=L">L</a></td>
                </tr>
                <tr>
                    <td colspan="3"><a href="click?key=noshift"><img src="img/noshift.svg" style="width:3ch"></a>
                    </td>
                    <td><a href="click?key=Z">Z</a></td>
                    <td> </td>
                    <td><a href="click?key=X">X</a></td>
                    <td> </td>
                    <td><a href="click?key=C">C</a></td>
                    <td> </td>
                    <td><a href="click?key=V">V</a></td>
                    <td> </td>
                    <td><a href="click?key=B">B</a></td>
                    <td> </td>
                    <td><a href="click?key=N">N</a></td>
                    <td> </td>
                    <td><a href="click?key=M">M</a></td>
                    <td colspan="3" style="text-align:right"><a href="click?key=del"><img src="img/delete.svg"></a>
                    </td>
                </tr>


                <tr>
                    <td colspan="3"><a href="click?key=numbers">123</a></td>
                    <td> </td>
                    <td><a href="click?key=.">.</a></td>
                    <td> </td>
                    <td colspan="7" style="text-align: center;"><a href="click?key=space"><img src="img/space.svg"
                                style="height:1.5em"></a></td>
                    <td> </td>
                    <td><a href="click?key=,">,</a></td>
                    <td> </td>
                    <td colspan="3" style="text-align:right"><a href="click?key=enter"><img src="img/enter.svg"></a>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
`;


tablesForKeyboard[SYMBOLS_1] =
    `
    <div class="container">
<table class="keyboard">
    <tbody>
        <tr>
            <td><a href="click?key=1">1</a></td>
            <td> </td>
            <td><a href="click?key=2">2</a></td>
            <td> </td>
            <td><a href="click?key=3">3</a></td>
            <td> </td>
            <td><a href="click?key=4">4</a></td>
            <td> </td>
            <td><a href="click?key=5">5</a></td>
            <td> </td>
            <td><a href="click?key=6">6</a></td>
            <td> </td>
            <td><a href="click?key=7">7</a></td>
            <td> </td>
            <td><a href="click?key=8">8</a></td>
            <td> </td>
            <td><a href="click?key=9">9</a></td>
            <td> </td>
            <td><a href="click?key=0">0</a></td>
        </tr>
        <tr>
            <td><a href="click?key=@">@</a></td>
            <td> </td>
            <td><a href="click?key=#">#</a></td>
            <td> </td>
            <td><a href="click?key=$">$</a></td>
            <td> </td>
            <td><a href="click?key=_">_</a></td>
            <td> </td>
            <td><a href="click?key=amp">&amp;</a></td>
            <td> </td>
            <td><a href="click?key=-">-</a></td>
            <td> </td>
            <td><a href="click?key=plus">+</a></td>
            <td> </td>
            <td><a href="click?key=(">(</a></td>
            <td> </td>
            <td><a href="click?key=)">)</a></td>
            <td> </td>
            <td><a href="click?key=slash">/</a></td>
        </tr>

        <tr>
            <td colspan="3"><a href="click?key=other-symbols">=\&lt;</a></td>
            <td><a href="click?key=*">*</a></td>
            <td> </td>
            <td><a href='click?key="'>"</a></td>
            <td> </td>
            <td><a href="click?key='">'</a></td>
            <td> </td>
            <td><a href="click?key=colon">:</a></td>
            <td> </td>
            <td><a href="click?key=semicolon">;</a></td>
            <td> </td>
            <td><a href="click?key=exclamationMark">!</a></td>
            <td> </td>
            <td><a href="click?key=questionMark">?</a></td>
            <td colspan="3" style="text-align:right"><a href="click?key=del"><img src="img/delete.svg"></a>
            </td>
        </tr>

        <tr>
            <td colspan="2"><a href="click?key=alphabet">ABC</a></td>
            <td> </td>
            <td><a href="click?key=.">.</a></td>
            <td> </td>
            <td colspan="8" style="text-align: center;"><a href="click?key=space"><img src="img/space.svg"
                        style="height:1.5em"></a></td>
            <td> </td>
            <td><a href="click?key=,">,</a></td>
            <td> </td>
            <td colspan="3" style="text-align:right"><a href="click?key=enter"><img src="img/enter.svg"></a>
            </td>
        </tr>
    </tbody>
</table>
</div>
`;


tablesForKeyboard[SYMBOLS_2] =
    `


<div class="container">
<table class="keyboard">
    <tbody>
        <tr>
            <td> </td>
            <td> </td>
            <td><a href="click?key=tilde">~</a></td>
            <td> </td>
            <td><a href="click?key=backtick">&#96;</a></td>
            <td> </td>
            <td><a href="click?key=vertDash">|</a></td>
            <td> </td>
            <td><a href="click?key=caret">^</a></td>
            <td> </td>
            <td><a href="click?key=equal">=</a></td>
            <td> </td>
            <td><a href="click?key=curlyOpen">{</a></td>
            <td> </td>
            <td><a href="click?key=curlyClose">}</a></td>
            <td> </td>
            <td><a href="click?key=backslash">\\</a></td>
            <td> </td>
        </tr>
        <tr>

            <td colspan="3"><a href="click?key=numbers">-/+</a></td>
            <td> </td>
            <td> </td>
            <td><a href="click?key=bracketOpen">[</a></td>
            <td> </td>
            <td><a href="click?key=bracketClose">]</a></td>
            <td> </td>
            <td><a href="click?key=percent">%</a></td>
            <td> </td>
            <td><a href="click?key=lt">&lt;</a></td>
            <td> </td>
            <td><a href="click?key=gt">&gt;</a></td>
            <td> </td>
            <td colspan="3" style="text-align:right"><a href="click?key=del"><img src="img/delete.svg"></a>
            </td>
        </tr>
        <tr>
            <td colspan="2"><a href="click?key=alphabet">ABC</a></td>
            <td> </td>
            <td><a href="click?key=.">.</a></td>
            <td> </td>
            <td colspan="8" style="text-align: center;"><a href="click?key=space"><img src="img/space.svg"
                        style="height:1.5em"></a></td>
            <td> </td>
            <td><a href="click?key=,">,</a></td>
            <td> </td>
            <td colspan="3" style="text-align:right"><a href="click?key=enter"><img src="img/enter.svg"></a>
            </td>
        </tr>
    </tbody>
</table>
</div>

`;




htmlTopPart =
    `
<!DOCTYPE html>
<html>
<head>
    <link rel="icon" href="data:,">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="img/https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="img/https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="./keyboard.css">
</head>
<body>
    <div class="container">
        <h3>Please enter your text here</h3>

        <pre>
`;

htmlSecondPart = `
</pre>
    </div>
`;

